------------------------------------------------------------
-- 			TEAM FORTRESS 2 Achievements Script			  --
--	    Made for TEAM FORTRESS 2 mod by [I~K] EngiN33R	  --
-- 		Copyright [I~K] EngiN33R. All rights reserved.    --
-- Do not copy any materials without asking creator first --
------------------------------------------------------------

--[[


INTRO
I made this mod mostly for my amusement, but when I saw that it's getting bigger 
and cooler, I decided to release it. I am aware that Team Fortress 2 scripts were
made in CS2D a dozen of times, yet still, I did want to make one myself. Thanks
for downloading it and looking it through, I do hope you like it.

INTRO TO ACHIEVEMENTS
After I made the main script fairly stable, I decided to do achievements similar 
to TF2 ones. I wanted to make this user-friendly, but for now it's just a script.
If you want to add some more achievements yourself, then:
IF you've got enough Lua skill, then do it yourself;
IF you haven't got enough Lua skill, just post your ideas here: %link%
Anyways, notify me in any way when you want to modify the script.
You can contact me via:
MSN - engin33r@live.ru
Skype - chapaev50
Xfire - chapaev50
E-mail - painttool@yandex.ru OR painttool@gmail.com
And thanks for downloading this script again.


DOOT DOOT DOOT DOOT DOODOODOODOODOOT
]]

if tf2==nil then tf2={} end
tf2.achievements={}

function initArray(f,v)
	local cmd = {}
	for c = 1, f do
		cmd[c] = v
	end
	return cmd
end

function initArray3(f,x,v)
	local cmd = {}
	for c = 1, f do
		cmd[c] = {x,v}
	end
	return cmd
end

--[[
    Heavy Pack:
Achievement ID 1 - Cap Master - Capture 5 points
Achievement ID 2 - Rampage - Kill 10 people in a single life
Achievement ID 3 - I <3 BIG guns - Destroy 5 any buildings using your Minigun
Achievement ID 4 - Heavy Milestone 1 - Milestone 1 (3 achievements completed) - Reward: Sandvich
Achievement ID 5 - Eat it up - Eat 10 Sandviches
Achievement ID 6 - Boxing Pro - Kill 20 people with your fists
Achievement ID 7 - Ze Soviet Might - Take 500 HP damage in single round

    Engineer Pack:
Achievement ID 8 - Wrench Newbie - Build 5 buildings
Achievement ID 9 - Wrench Amateur - Build 10 buildings
Achievement ID 10 - Wrench Master - Build 20 buildings
Achievement ID 11 - Engineer Milestone 1 - Milestone 1 (3 achievements completed) - Reward: Gunslinger

    Sniper Pack:
Achievement ID 12 - Scoped Maniac - Kill 10 enemies with your sniper rifle
Achievement ID 13 - Wrong Sniper - Kill 5 enemies with your SMG
Achievement ID 14 - Crocodile Hunter - Kill 5 Heavies with your Kukri
Achievement ID 15 - Sniper Milestone 1 - Milestone 1 (3 achievements completed) - Reward: Jarate

    Scout Pack:
Achievement ID 16 - Jogging Expert - Run 1000 tiles
Achievement ID 17 - Force-A-Nature - Kill 15 enemies with your Force-a-nature
Achievement ID 18 - High League - Beat 5 Scout morons to death
Achievement ID 19 - Scout Milestone 1 - Milestone 1 (3 achievements completed) - Reward: Bonk! Atomic Punch

    Medic Pack (WIP, none done):
Achievement ID 20 - Great Doktor - Heal 500 HP to a single player
Achievement ID 21 - Deutsche Vampiren - Suck 250 HP using Blutsauger
Achievement ID 22 - UberMedic - Kill 10 enemies with Ubersaw
Achievement ID 23 - Medic Milestone 1 - Milestone 1 (3 achievements completed) - Reward: Kritzkrieg

    
]]

tf2.achievements.number=initArray(32,0) -- number of total achievements completed by a player (used for lifetime milestones)
tf2.achievements.state=initArray3(32,{0,true}) -- first array number is achievement ID, second array boolean is whether it's done or not
tf2.achievements.completed=initArray3(32,{0,false}) -- first array number is achievement ID, second array boolean is whether it's done or not (used for rewards)
tf2.achievements.scout=initArray(32,0) -- these 9 are numbers of achievements for a certain class completed by a player (used for class milestones)
tf2.achievements.soldier=initArray(32,0)
tf2.achievements.pyro=initArray(32,0)
tf2.achievements.demoman=initArray(32,0)
tf2.achievements.heavy=initArray(32,0)
tf2.achievements.engineer=initArray(32,0)
tf2.achievements.medic=initArray(32,0)
tf2.achievements.sniper=initArray(32,0)
tf2.achievements.spy=initArray(32,0)

tf2.achievements.heavycaps=initArray(32,0)
tf2.achievements.heavykills=initArray(32,0)
tf2.achievements.heavygriefs=initArray(32,0)
tf2.achievements.heavydamage=initArray(32,0)
tf2.achievements.heavymelees=initArray(32,0)
tf2.achievements.heavyeaten=initArray(32,0)

tf2.achievements.engibuildings=initArray(32,0)

tf2.achievements.sniperheadshots=initArray(32,0)
tf2.achievements.snipersmgs=initArray(32,0)
tf2.achievements.sniperhvykukris=initArray(32,0)

tf2.achievements.tilesran=initArray(32,0)
tf2.achievements.fankills=initArray(32,0)
tf2.achievements.scoutsbeaten=initArray(32,0)

for i=1,20 do
	for id=1,32 do
		tf2.achievements.completed[id][i]=false
		tf2.achievements.state[id][i]=true
	end
end

addhook("movetile","tf2.achievements.movetile")
function tf2.achievements.movetile(id)
	if (tf2.classes.class[id]==1 and tf2.achievements.state[id][16]==true) then
		tf2.achievements.tilesran[id]=tf2.achievements.tilesran[id]+1
		if (tf2.achievements.tilesran[id]==1000) then
			tf2.achievements.tilesran[id]=0
			tf2.achievements.state[id][16]=false
			tf2.achievements.completed[id][16]=true
			tf2.achievements.number[id]=tf2.achievements.number[id]+1
			tf2.achievements.scout[id]=tf2.achievements.scout[id]+1
			msg(player(id,"name").." has completed Jogging Expert achievement!")
		end
	end
end

addhook("dominate","tf2.achievements.domination")
function tf2.achievements.domination(id)
	if (tf2.classes.class[id]==5) then
		tf2.achievements.heavycaps[id]=tf2.achievements.heavycaps[id]+1
		if (tf2.achievements.heavycaps[id]==5) then
			tf2.achievements.heavycaps[id]=0
			tf2.achievements.state[id][1]=false
			tf2.achievements.completed[id][1]=true
			tf2.achievements.number[id]=tf2.achievements.number[id]+1
			tf2.achievements.heavy[id]=tf2.achievements.heavy[id]+1
			msg(player(id,"name").." has completed Cap Master achievement!")
		end
	end
end

addhook("kill","tf2.achievements.kill")
function tf2.achievements.kill(k,v,w)
	if (tf2.classes.class[k]==1 and tf2.classes.class[v]==1 and tf2.achievements.state[k][18]==true and w==69) then
		tf2.achievements.scoutsbeaten[k]=tf2.achievements.scoutsbeaten[k]+1
		if (tf2.achievements.scoutsbeaten[k]==5) then
			tf2.achievements.scoutsbeaten[k]=0
			tf2.achievements.state[k][18]=false
			tf2.achievements.completed[k][18]=true
			tf2.achievements.number[k]=tf2.achievements.number[k]+1
			tf2.achievements.scout[k]=tf2.achievements.scout[k]+1
			msg(player(k,"name").." has completed High League achievement!")
		end
	end
	if (tf2.classes.class[k]==1 and tf2.achievements.state[k][17]==true and w==11 and tf2.classes.primaryunlock[k][1]==3) then
		tf2.achievements.fankills[k]=tf2.achievements.fankills[k]+1
		if (tf2.achievements.fankills[k]==5) then
			tf2.achievements.fankills[k]=0
			tf2.achievements.state[k][17]=false
			tf2.achievements.completed[k][17]=true
			tf2.achievements.number[k]=tf2.achievements.number[k]+1
			tf2.achievements.scout[k]=tf2.achievements.scout[k]+1
			msg(player(k,"name").." has completed Force-A-Nature achievement!")
		end
	end
	if (tf2.classes.class[k]==5 and tf2.achievements.state[k][2]==true) then
		tf2.achievements.heavykills[k]=tf2.achievements.heavykills[k]+1
		if (tf2.achievements.heavykills[k]==10) then
			tf2.achievements.heavykills[k]=0
			tf2.achievements.state[k][2]=false
			tf2.achievements.completed[k][2]=true
			tf2.achievements.number[k]=tf2.achievements.number[k]+1
			tf2.achievements.heavy[k]=tf2.achievements.heavy[k]+1
			msg(player(k,"name").." has completed Rampage achievement!")
		end
	end
	if (tf2.classes.class[k]==8 and tf2.classes.class[v]==5 and w==69 and tf2.achievements.state[k][14]==true) then
		tf2.achievements.sniperhvykukris[k]=tf2.achievements.sniperhvykukris[k]+1
		if (tf2.achievements.sniperhvykukris[k]==5) then
			tf2.achievements.state[k][14]=false
			tf2.achievements.completed[k][14]=true
			tf2.achievements.number[k]=tf2.achievements.number[k]+1
			tf2.achievements.sniper[k]=tf2.achievements.sniper[k]+1
			msg(player(k,"name").." has completed Elephant Hunter achievement!")
		end
	end
	if (tf2.classes.class[k]==8 and w==24 and tf2.achievements.state[k][13]==true) then
		tf2.achievements.snipersmgs[k]=tf2.achievements.snipersmgs[k]+1
		if (tf2.achievements.snipersmgs[k]==5) then
			tf2.achievements.state[k][13]=false
			tf2.achievements.completed[k][13]=true
			tf2.achievements.number[k]=tf2.achievements.number[k]+1
			tf2.achievements.sniper[k]=tf2.achievements.sniper[k]+1
			msg(player(k,"name").." has completed Wrong Sniper achievement!")
		end
	end
	if (tf2.achievements.heavykills[v]>0 and tf2.achievements.state[v][2]==true) then
		tf2.achievements.heavykills[v]=0
	end
	if (tf2.classes.class[k]==5 and w==78) then
		tf2.achievements.heavymelees[k]=tf2.achievements.heavymelees[k]+1
		if (tf2.achievements.heavymelees[k]==20) then
			tf2.achievements.heavymelees[k]=0
			tf2.achievements.state[k][6]=false
			tf2.achievements.completed[k][6]=true
			tf2.achievements.number[k]=tf2.achievements.number[k]+1
			tf2.achievements.heavy[k]=tf2.achievements.heavy[k]+1
			msg(player(k,"name").." has completed Boxing Pro achievement!")
		end
	end
	if (tf2.classes.class[k]==8 and w==35) then
		tf2.achievements.sniperheadshots[k]=tf2.achievements.sniperheadshots[k]+1
		if (tf2.achievements.sniperheadshots[k]==10) then
			tf2.achievements.sniperheadshots[k]=0
			tf2.achievements.state[k][11]=false
			tf2.achievements.completed[k][11]=true
			tf2.achievements.number[k]=tf2.achievements.number[k]+1
			tf2.achievements.sniper[k]=tf2.achievements.sniper[k]+1
			msg(player(k,"name").." has completed Scoped maniac achievement!")
			tf2.craft.weaponstack[id][24]=1
		end
	end
end

addhook("die","tf2.achievements.die")
function tf2.achievements.die(id)
	if (tf2.classes.class[id]==5 and tf2.achievements.state[id][2]==true and tf2.achievements.heavykills[id]>0) then
		tf2.achievements.heavykills[id]=0
	end
end

addhook("objectkill","tf2.achievements.objectkill")
function tf2.achievements.objectkill(obj,id)
	if (tf2.classes.class[id]==5 and player(id,"weapontype")==40) then
		tf2.achievements.heavygriefs[id]=tf2.achievements.heavygriefs[id]+1
		if (tf2.achievements.heavygriefs[id]==5) then
			tf2.achievements.heavygriefs[id]=0
			tf2.achievements.state[id][3]=false
			tf2.achievements.completed[id][3]=true
			tf2.achievements.number[id]=tf2.achievements.number[id]+1
			tf2.achievements.heavy[id]=tf2.achievements.heavy[id]+1
			msg(player(id,"name").." has completed I <3 BIG guns achievement!")
		end
	end
end

addhook("spawn","tf2.achievements.milestones")
function tf2.achievements.milestones(id)
	if (tf2.achievements.heavy[id]>=3 and tf2.achievements.heavy[id]<8 and tf2.achievements.completed[id][4]==false) then
		tf2.achievements.state[id][4]=false
		tf2.achievements.completed[id][4]=true
		tf2.achievements.number[id]=tf2.achievements.number[id]+1
		tf2.achievements.heavy[id]=tf2.achievements.heavy[id]+1
		msg(player(id,"name").." has completed Heavy Milestone 1 achievement!")
		msg(player(id,"name").." has found: Sandvich")
		tf2.craft.weaponstack[id][17]=1
	end
	if (tf2.achievements.engineer[id]>=3 and tf2.achievements.engineer[id]<8  and tf2.achievements.completed[id][11]==false) then
		tf2.achievements.state[id][11]=false
		tf2.achievements.completed[id][11]=true
		tf2.achievements.number[id]=tf2.achievements.number[id]+1
		tf2.achievements.engineer[id]=tf2.achievements.engineer[id]+1
		msg(player(id,"name").." has completed Engineer Milestone 1 achievement!")
		msg(player(id,"name").." has found: Southern Hospitality")
		tf2.craft.weaponstack[id][8]=1
	end
	if (tf2.achievements.sniper[id]>=3 and tf2.achievements.sniper[id]<8 and tf2.achievements.completed[id][15]==false) then
		tf2.achievements.state[id][15]=false
		tf2.achievements.completed[id][15]=true
		tf2.achievements.number[id]=tf2.achievements.number[id]+1
		tf2.achievements.sniper[id]=tf2.achievements.sniper[id]+1
		msg(player(id,"name").." has completed Sniper Milestone 1 achievement!")
		msg(player(id,"name").." has found: Jarate")
		tf2.craft.weaponstack[id][16]=1
	end
	if (tf2.achievements.scout[id]>=3 and tf2.achievements.scout[id]<8 and tf2.achievements.completed[id][19]==false) then
		tf2.achievements.state[id][19]=false
		tf2.achievements.completed[id][19]=true
		tf2.achievements.number[id]=tf2.achievements.number[id]+1
		tf2.achievements.scout[id]=tf2.achievements.scout[id]+1
		msg(player(id,"name").." has completed Scout Milestone 1 achievement!")
		msg(player(id,"name").." has found: Bonk! Atomic Punch")
		tf2.craft.weaponstack[id][17]=1
	end
end

addhook("hit","tf2.achievements.hit")
function tf2.achievements.hit(id,source,weapon,hpdmg)
	if (tf2.classes.class[id]==5 and tf2.achievements.completed[id][7]==false) then
		tf2.achievements.heavydamage[id]=tf2.achievements.heavydamage[id]+hpdmg
		if (tf2.achievements.heavydamage[id]>=500) then
			tf2.achievements.heavydamage[id]=0
			tf2.achievements.state[id][7]=false
			tf2.achievements.completed[id][7]=true
			tf2.achievements.number[id]=tf2.achievements.number[id]+1
			tf2.achievements.heavy[id]=tf2.achievements.heavy[id]+1
			msg(player(id,"name").." has completed Ze Soviet Might achievement!")
		end
	end
end

addhook("startround","tf2.achievements.startround")
function tf2.achievements.startround()
	for id=1,32 do
		tf2.achievements.heavydamage[id]=0
	end
end

addhook("build","tf2.achievements.build")
function tf2.achievements.build(id,type)
	if (tf2.classes.class[id]==6 and tf2.achievements.completed[id][8]==false) then
		tf2.achievements.engibuildings[id]=tf2.achievements.engibuildings[id]+1
		if (tf2.achievements.engibuildings[id]==5) then
			tf2.achievements.engibuildings[id]=0
			tf2.achievements.state[id][8]=false
			tf2.achievements.completed[id][8]=true
			tf2.achievements.number[id]=tf2.achievements.number[id]+1
			tf2.achievements.engineer[id]=tf2.achievements.engineer[id]+1
			msg(player(id,"name").." has completed Wrench Newbie achievement!")
		end
		if (tf2.achievements.engibuildings[id]==10) then
			tf2.achievements.engibuildings[id]=0
			tf2.achievements.state[id][9]=false
			tf2.achievements.completed[id][9]=true
			tf2.achievements.number[id]=tf2.achievements.number[id]+1
			tf2.achievements.engineer[id]=tf2.achievements.engineer[id]+1
			msg(player(id,"name").." has completed Wrench Amateur achievement!")
		end
		if (tf2.achievements.engibuildings[id]==20) then
			tf2.achievements.engibuildings[id]=0
			tf2.achievements.state[id][10]=false
			tf2.achievements.completed[id][10]=true
			tf2.achievements.number[id]=tf2.achievements.number[id]+1
			tf2.achievements.engineer[id]=tf2.achievements.engineer[id]+1
			msg(player(id,"name").." has completed Wrench Master achievement!")
		end
	end
end
