if tf2==nil then tf2={} end
tf2.craft={}

function initArray2(f,v)
	local cmd = {}
	for c = 1, f do
		cmd[c] = v
	end
	return cmd
end

function initArray3(f,x,v)
	local cmd = {}
	for c = 1, f do
		cmd[c] = {x,v}
	end
	return cmd
end

-------------
-- RIDDLES --
-------------

-- The 2010 Christmas update riddle competition winner - The Geek
-- The winner is Leo!
thegeek=5910



tf2.craft.enabled=true -- Enable craft?

tf2.craft.price=initArray2(256,0) -- Prices table for the Mann Co. Store

tf2.craft.scrapnumber=initArray2(32,0)
tf2.craft.reclaimednumber=initArray2(32,0)
tf2.craft.refinednumber=initArray2(32,0)
tf2.craft.token=initArray3(32,{0,0})
tf2.craft.christmasnumber=initArray2(32,0)
tf2.craft.stvalentinesnumber=initArray2(32,0)
tf2.craft.halloweennumber=initArray2(32,0)

tf2.craft.credits=initArray2(32,0)

tf2.craft.weaponstack=initArray3(32,{0,0}) -- first array number is ID of the item, second array number is the amount of items stacked

tf2.craft.freeslot=initArray2(32,1)
tf2.craft.item=initArray3(32,{1,0}) -- first array number is ID of the slot, second array number is ID of the item in the slot

hat=initArray2(32,0) -- HATS!

tf2.craft.itemstack=initArray2(32,0) -- used for temporary weapon manipulations
tf2.craft.selectstack=initArray2(32,0) -- select stacks are used for Switch Weapon menus
tf2.craft.selectstack2=initArray2(32,0)
tf2.craft.selectstack3=initArray2(32,0)
tf2.craft.selectstack4=initArray2(32,0)

for i=1,9 do
	for id=1,32 do
		tf2.craft.token[id][i]=0
	end
end

function get(array,array2,array3)
	print(tostring(array))
	if (array2~=nil) then
		print(tostring(array[array2]))
	end
	if (array2~=nil and array3~=nil) then
		print(tostring(array[array2][array3]))
	end
end

--[[

Items:
ID 1 - Scrap Metal - Level 1 crafting material
ID 2 - Reclaimed Metal - Level 2 crafting material
ID 3 - Force-a-Nature - +20% damage
ID 4 - Black Box - +15 HP on hit
ID 5 - The Backburner - +10% damage
ID 6 - Chargin' Targe - +100% speed on wearer for 3 seconds when activated
ID 7 - Dalokohs Bar - Heals 70 HP for 4 seconds, gives overheal when on max HP (+25 hp)
ID 8 - Southern Hospitality - Enemy recieves bleeding effect for 5 seconds (-7 hp/s)
ID 9 - Ubersaw - Replenishes 10% of a Medic's HP per kill
ID 10 - Sydney Sleeper - Makes all hits on target mini-crits (+35% dmg) for 8 seconds
ID 11 - Dead Ringer - Feigns wearer's death on hit, wearer can't cloak
ID 12 - Natascha - On hit slows down by 15%, -15% damage
ID 13 - Blutsauger - On hit replenishes 3 HP, -3 HP drain
ID 14 - Cloak and Dagger - Only drains cloak charge when moving
ID 15 - Refined Metal - Level 3 crafting material
ID 16 - Microchip - Level 5 crafting material (Binned - 11/2/2010) (Got out of trash bin - 11/5/2010) (Delayed - 11/9/2010)
ID 24 - Jarate - Mini-crits (+35% dmg) on target for 10 seconds
ID 25 - Sandvich - Replenishes 100% of Heavy's HP instantly

----------------------------------------------------------------

Blueprints:
Combine Reclaimed Metal - 3 Scrap Metal
Fabricate headgear - 4 Reclaimed Metal
Fabricate any weapon - 1 Reclaimed Metal
Fabricate class/slot token - 3 Reclaimed Metal
Fabricate a Class Weapon - Class token+2 Scrap Metal (NOT IMPLEMENTED)
Fabricate a Slot Weapon - Primary/Secondary token+2 Scrap Metal (NOT IMPLEMENTED)
Fabricate a Class Slot weapon - Class token+Slot token+2 Scrap Metal (NOT IMPLEMENTED)

]]

crafts = { -- the weapons database: contains every weapon name, description, stats, class and slot. very handy

[0] = {
	name = "",
},

[1] = {
	name = "Scrap Metal",
	desc = "Level 1 Crafting Material",
},

[2] = {
	name = "Reclaimed Metal",
	desc = "Level 2 Crafting Material",
},

[3] = {
	name = "Force-a-nature",
	desc = "Level 10 Scattergun",
	func = "+20% damage",
	class = 1,
	slot = 1,
	id = 11,
	atk = 20,
},

[4] = {
	name = "Black Box",
	desc = "Level 5 Rocket Launcher",
	func = "+15% HP on hit",
	class = 2,
	slot = 1,
	id = 48,
	hp = 20,
	spd = -10,
	atk = 0,
	minhp = 30,
},

[5] = {
	name = "The Backburner",
	desc = "Level 10 Flamethrower",
	func = "-20% damage; +30% damage when burning player's back",
	class = 3,
	slot = 1,
	id = 46,
	atk = 30,
	minhp = 10,
},

[6] = {
	name = "Chargin' Targe",
	desc = "Level 10 Shield",
	func = "35 speed on wearer for 1 seconds; +20 fire resistance",
	class = 4,
	slot = 2,
	def = 20,
},

[7] = {
	name = "Dalokohs Bar",
	desc = "Level 1 Lunch box",
	func = "Heals 70 HP for 4 seconds; gives overheal when on max HP (+25 hp)",
	class = 5,
	id = 54,
	slot = 2,
},

[8] = {
	name = "Southern Hospitality",
	desc = "Level 20 Wrench",
	func = "Enemy receives bleeding effect for 5 seconds (-7 hp/s)",
	class = 6,
	id = 74,
	slot = 3,
},

[9] = {
	name = "Ubersaw",
	desc = "Level 10 Bonesaw",
	func = "Replenishes 20% of Medic's max HP per kill",
	class = 7,
	id = 85,
	slot = 3,
	minhp = 27,
	atk = 1,
},

[10] = {
	name = "Sydney Sleeper",
	desc = "Level 10 Sniper Rifle",
	func = "Makes all hits on target minicrits (+35% damage) for 8 seconds",
	class = 8,
	slot = 1,
	id = 35,
},

[11] = {
	name = "Dead Ringer",
	desc = "Level 5 Invis Watch",
	func = "Feigns wearer's death on hit; wearer can't cloak",
	class = 9,
	slot = 4,
	id = 50,
},

[12] = {
	name = "Natascha",
	desc = "Level 5 Minigun",
	func = "On hit slows down by 15%; -15% damage",
	class = 5,
	slot = 1,
	id = 40,
},

[13] = {
	name = "Blutsauger",
	desc = "Level 5 Syringe Gun",
	func = "+3 HP on hit; -10 HP on wearer",
	class = 7,
	slot = 1,
	id = 24,
},

[14] = {
	name = "Cloak and Dagger",
	desc = "Level 5 Invis Watch",
	func = "Only drains cloak when moving",
	class = 9,
	slot = 4,
	id = 50,
},

[15] = {
	name = "Jarate",
	desc = "Level 5 Jar Based Karate",
	func = "Coated enemies take Mini-crits (+35% dmg)",
	class = 8,
	slot = 2,
	id = 51,
},

[16] = {
	name = "Sandvich",
	desc = "Level 5 Lunchbox",
	func = "Replenishes 100% of Heavy's HP; unable to move for 4 seconds",
	class = 5,
	slot = 2,
	id = 54,
},

[17] = {
	name = "Bonk! Atomic Punch",
	desc = "Level 5 Lunchbox",
	func = "Makes Scout invulnerable for 5 seconds",
	class = 1,
	slot = 2,
	id = 54,
},

[18] = {
	name = "Gunslinger",
	desc = "Level 15 Robot Arm",
	func = "+15 max health; instantly builds dispensers",
	class = 6,
	slot = 3,
	id = 74,
},

[19] = {
	name = "Kritzkrieg",
	desc = "Level 8 Medigun",
	func = "Heals for 3 HP/sec instead of 1; -10 HP on wearer",
	class = 7,
	slot = 2,
	id = 22,
},

[20] = {
	name = "The Afterburner",
	desc = "Level 15 Flamethrower",
	func = "-15 HP damage; +4 damage from afterburn; +5 seconds afterburn time",
	class = 3,
	slot = 1,
	id = 46,
},

[21] = {
	name = "Class Token - Scout",
	desc = "Level 1 Crafting Token",
	class = 1,
},

[22] = {
	name = "Class Token - Soldier",
	desc = "Level 1 Crafting Token",
	class = 2,
},

[23] = {
	name = "Class Token - Pyro",
	desc = "Level 1 Crafting Token",
	class = 3,
},

[24] = {
	name = "Class Token - Demoman",
	desc = "Level 1 Crafting Token",
	class = 4,
},

[25] = {
	name = "Class Token - Heavy",
	desc = "Level 1 Crafting Token",
	class = 5,
},

[26] = {
	name = "Class Token - Engineer",
	desc = "Level 1 Crafting Token",
	class = 6,
},

[27] = {
	name = "Class Token - Medic",
	desc = "Level 1 Crafting Token",
	class = 7,
},

[28] = {
	name = "Class Token - Sniper",
	desc = "Level 1 Crafting Token",
	class = 8,
},

[29] = {
	name = "Class Token - Spy",
	desc = "Level 1 Crafting Token",
	class = 9,
},

[30] = {
	name = "Refined Metal",
	desc = "Level 3 Crafting Material",
},

[31] = {
	name = "Batter's helm",
	desc = "Level 1-100",
	func = "Hat",
	class = 1,
	slot = 5,
	image = "gfx/tf2/batters_helm.png",
},

[32] = {
	name = "Soldier's stash",
	desc = "Level 1-100",
	func = "Hat",
	class = 2,
	slot = 5,
	image = "gfx/tf2/soldiers_stash.png",
},

[33] = {
	name = "Pyro's beanie",
	desc = "Level 1-100",
	func = "Hat",
	class = 3,
	slot = 5,
	image = "gfx/tf2/pyros_beanie.png",
},

[34] = {
	name = "Glengarry bonnet",
	desc = "Level 1-100",
	func = "Hat",
	class = 4,
	slot = 5,
	image = "gfx/tf2/glengarry_bonnet.png",
},

[35] = {
	name = "Football helmet",
	desc = "Level 1-100",
	func = "Hat",
	class = 5,
	slot = 5,
	image = "gfx/tf2/football_helmet.png",
},

[36] = {
	name = "Mining light",
	desc = "Level 1-100",
	func = "Hat",
	class = 6,
	slot = 5,
	image = "gfx/tf2/mining_light.png",
},

[37] = {
	name = "Prussian pickelhaube",
	desc = "Level 1-100",
	func = "Hat",
	class = 7,
	slot = 5,
	image = "gfx/tf2/prussian_pickelhaube.png",
},

[38] = {
	name = "Trophy belt",
	desc = "Level 1-100",
	func = "Hat",
	class = 8,
	slot = 5,
	image = "gfx/tf2/trophy_belt.png",
},

[39] = {
	name = "Fancy fedora",
	desc = "Level 1-100",
	func = "Hat",
	class = 9,
	slot = 5,
	image = "gfx/tf2/fancy_fedora.png",
},

[40] = {
	name = "Santa's Hat",
	desc = "Level 1-100",
	func = "Hat",
	slot = 5,
	image = "gfx/tf2/santas_hat.png",
},

[41] = {
	name = "Gift Launcher",
	desc = "Level 43 Rocket Launcher",
	func = "Spawns gifts on victim's body; spawns either medkit or ammo",
	class = 2,
	slot = 1,
	id = 48,
},

[42] = {
	name = "Santa Caller",
	desc = "Level 7 Radio",
	func = "Calls in a medkit and ammunition; works once per life; -15 max HP",
	class = 7,
	slot = 4,
	id = 50,
},

[43] = {
	name = "Santa's Enchanted Metal",
	desc = "Level 1 Special Crafting Material",
},

[44] = {
	name = "Christmas Spirit",
	desc = "Level 12 Faith",
	func = "Makes you invulnerable for 10 seconds; explodes you after",
	class = 5,
	slot = 4,
	id = 78,
},

[45] = {
	name = "Rudolph's Magic Antlers",
	desc = "Level 1-100 Hat",
	func = "Hat",
	slot = 5,
	image = "gfx/tf2/antlers.png",
},

[46] = {
	name = "Supply Crate Series #1",
	desc = "Level 100 Cargo Crate",
	func = "You can find: Gunslinger; The Afterburner; Reclaimed Metal; Dealer's Visor; 5 Game Credits",
},

[47] = {
	name = "Christmas Festive Crate",
	desc = "Level 101 Cargo Crate",
	func = "You can find a random Christmas item!",
},

[48] = {
	name = "Supply Key",
	desc = "Level 100 Key",
	func = "Open crates with it",
},

[49] = {
	name = "Christmas Key",
	desc = "Level 101 Key",
	func = "Open Christmas crates with it",
},

[50] = {
	name = "Dealer's Visor",
	desc = "Level 1-100 Hat",
	func = "Hat",
	slot = 5,
	class = 5,
	image = "gfx/tf2/hats/dealers_visor.png",
},

[51] = {
	name = "Milkman",
	desc = "Level 1-100 Hat",
	func = "Hat",
	slot = 5,
	class = 1,
	image = "gfx/tf2/hats/milkman.png",
},

[52] = {
	name = "Familiar Fez",
	desc = "Level 1-100 Hat",
	func = "Hat",
	slot = 5,
	class = 9,
	image = "gfx/tf2/hats/familiar_fez.png",
},

[53] = {
	name = "Game Credit",
},

[54] = {
	name = "Supply Crate Series #2",
	desc = "Level 100 Cargo Crate",
	func = "You can find: Button of Untolerance; Natascha; Blutsauger; Enchanted Metal; 5 Game Credits",
},

[55] = {
	name = "Supply Crate Series #3",
	desc = "Level 100 Cargo Crate",
	func = "You can find: Kritzkrieg; Current Class Token; Refined Metal; Fabulous Boxing Item; 5 Game Credits",
},

[56] = {
	name = "A Very Festive Camouflage",
	desc = "Level 1-100 Hat",
	func = "Hat",
	slot = 5,
	class = "all",
	image = "gfx/tf2/christmas/hats/festive_camouflage.png",
},

[57] = {
	name = "Fabulous Boxing Item",
	desc = "Level 24 Boxing Gloves",
	func = "Casts bleed effect for 7 seconds; -5 speed",
	slot = 2,
	class = 5,
	id = 54,
},

[58] = {
	name = "Button of Untolerance",
	desc = "Level 50 Bomb",
	func = "Explodes player a la suicide bomber; blinds players around",
	slot = 1,
	class = 4,
	id = 50,
},

[59] = {
	name = "Geek's Brainy Hat",
	desc = "Level 72 Dedication Reward",
	func = "When a player's dedication is off any scales.",
	slot = 5,
	image = "gfx/tf2/brain_hat.png",
},

[60] = {
	name = "Officer's Ushanka",
	desc = "Level 0-100 Hat",
	func = "This hat was made from bear hands. The bear was killed with bare hands.",
	slot = 5,
	class = 5,
	image = "gfx/tf2/hats/officers_ushanka.png",
},

[61] = {
	name = "Sergeant's Drill Hat",
	desc = "Level 0-100 Hat",
	func = "Hat",
	slot = 5,
	class = 2,
	image = "gfx/tf2/hats/sergeant_drills_hat.png",
},

[62] = {
	name = "Tough Guy's Toque",
	desc = "Level 0-100 Hat",
	func = "Hat",
	slot = 5,
	class = 5,
	image = "gfx/tf2/hats/tough_guys_toque.png",
},

[63] = {
	name = "Gloves of Running Urgently",
	desc = "Level 15 Boxing Gloves",
	func = "Gives +10 speedmod, -4 HP every second",
	slot = 2,
	class = 5,
},

}

for item=1,59 do
	for id=1,32 do
		tf2.craft.weaponstack[id][item]=0
	end
end

function rewardsmenu(id)
	if (player(id,"usgn")==thegeek) then
		if (tf2.classes.hatunlock[id][tf2.classes.class[id]]~=59) then
			menu(id,"Rewards,Put on Brainy Hat")
		else
			menu(id,"Rewards,Remove Brainy Hat")
		end
	end
end

function cratesmenu(id)
	if (ischristmas) then
		menu(id,"Use a key,On Supply Crate #1,On Supply Crate #2,On Supply Crate #3,On Christmas Festive Crate")
	else
		menu(id,"Use a key,On Supply Crate #1,On Supply Crate #2,On Supply Crate #3")
	end
end

addhook("menu","tf2.craft.testmenu")
function tf2.craft.testmenu(id,menu,sel)
	if (menu=="Backpack") then
		if (sel==1) then
			weaponchoice(id,1)
		end
		if (sel==2) then
			weaponchoice(id,2)
		end
		if (sel==3) then
			weaponchoice(id,3)
		end
		if (sel==4) then
			weaponchoice(id,4)
		end
		if (sel==5) then
			weaponchoice(id,5)
		end
		if (sel==9) then
			cratesmenu(id)
		end
	end
	if (menu=="Rewards") then
		if (sel==1 and tf2.classes.hatunlock[id][tf2.classes.class[id]]~=59) then
			tf2.classes.hatunlock[id][tf2.classes.class[id]]=59
			if (hat[id]>0) then
				freeimage(hat[id])
			end
			hat[id]=image(crafts[tf2.classes.hatunlock[id][tf2.classes.class[id]]].image,1,0,200+id)
		elseif (sel==1 and tf2.classes.hatunlock[id][tf2.classes.class[id]]==59) then
			tf2.classes.hatunlock[id][tf2.classes.class[id]]=0
			freeimage(hat[id])
		end
	end
	if (menu=="Use a key") then
		if (sel==1) then
			if (tf2.craft.weaponstack[id][46]~=nil and tf2.craft.weaponstack[id][48]~=nil and tf2.craft.weaponstack[id][46]>0 and tf2.craft.weaponstack[id][48]>0) then
				tf2.craft.weaponstack[id][46]=tf2.craft.weaponstack[id][46]-1
				tf2.craft.weaponstack[id][48]=tf2.craft.weaponstack[id][48]-1
				local item=math.random(1,4)
				local rare=math.random(1,50)
				if (rare==39) then
					tf2.craft.addcredits(id,5)
				else
					if (item==1) then
						equip(id,8,"uncrate")
					end
					if (item==2) then
						equip(id,20,"uncrate")
					end
					if (item==3) then
						equip(id,2,"uncrate")
					end
					if (item==4) then
						equip(id,50,"uncrate")
					end
				end
			end
		end
		if (sel==2) then
			if (tf2.craft.weaponstack[id][54]~=nil and tf2.craft.weaponstack[id][48]~=nil and tf2.craft.weaponstack[id][54]>0 and tf2.craft.weaponstack[id][48]>0) then
				tf2.craft.weaponstack[id][54]=tf2.craft.weaponstack[id][54]-1
				tf2.craft.weaponstack[id][48]=tf2.craft.weaponstack[id][48]-1
				local item=math.random(1,4)
				local rare=math.random(1,50)
				if (rare==39) then
					tf2.craft.addcredits(id,5)
				else
					if (item==1) then
						equip(id,58,"uncrate")
					end
					if (item==2) then
						equip(id,12,"uncrate")
					end
					if (item==3) then
						equip(id,13,"uncrate")
					end
					if (item==4) then
						equip(id,43,"uncrate")
					end
				end
			end
		end
		if (sel==3) then
			if (tf2.craft.weaponstack[id][55]~=nil and tf2.craft.weaponstack[id][48]~=nil and tf2.craft.weaponstack[id][55]>0 and tf2.craft.weaponstack[id][48]>0) then
				tf2.craft.weaponstack[id][55]=tf2.craft.weaponstack[id][55]-1
				tf2.craft.weaponstack[id][48]=tf2.craft.weaponstack[id][48]-1
				local item=math.random(1,4)
				local rare=math.random(1,50)
				if (rare==39) then
					tf2.craft.addcredits(id,5)
				else
					if (item==1) then
						equip(id,19,"uncrate")
					end
					if (item==2) then
						tf2.craft.token[id][tf2.classes.class[id]]=tf2.craft.token[id][tf2.classes.class[id]]+1
						equip(id,tf2.classes.class[id]+20,"uncrate")
					end
					if (item==3) then
						equip(id,30,"uncrate")
					end
					if (item==4) then
						equip(id,57,"uncrate")
					end
				end
			end
		end
		if (sel==4) then
			if (tf2.craft.weaponstack[id][47]~=nil and tf2.craft.weaponstack[id][49]~=nil and tf2.craft.weaponstack[id][47]>0 and tf2.craft.weaponstack[id][49]>0) then
				tf2.craft.weaponstack[id][47]=tf2.craft.weaponstack[id][47]-1
				tf2.craft.weaponstack[id][49]=tf2.craft.weaponstack[id][49]-1
				local item=math.random(1,7)
				if (item==1) then
					equip(id,40,"uncrate")
				end
				if (item==2) then
					equip(id,41,"uncrate")
				end
				if (item==3) then
					equip(id,42,"uncrate")
				end
				if (item==4) then
					equip(id,44,"uncrate")
				end
				if (item==5) then
					equip(id,43,"uncrate")
				end
				if (item==6) then
					equip(id,45,"uncrate")
				end
			end
		end
	end
end

function tf2.craft.additem(id,item)
	if (item==1) then
		tf2.craft.scrapnumber[id]=tf2.craft.scrapnumber[id]+1
	elseif (item==2) then
		tf2.craft.reclaimednumber[id]=tf2.craft.reclaimednumber[id]+1
	elseif (item==30) then
		tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]+1
	elseif (item==43) then
		tf2.craft.christmasnumber[id]=tf2.craft.christmasnumber[id]+1
	else
		if (tf2.craft.weaponstack[id][item]==nil) then
			tf2.craft.weaponstack[id][item]=1
		else
			tf2.craft.weaponstack[id][item]=tf2.craft.weaponstack[id][item]+1
		end
	end
end

function tf2.craft.addcredits(id,count)
	if (player(id,"exists")) then
		if (tf2.craft.credits[id]==nil) then
			tf2.craft.credits[id]=1
		else
			tf2.craft.credits[id]=tf2.craft.credits[id]+count
		end
		msg2(id,"You have received "..count.." "..plural(count,"Game Credit").." for playing.")
	end
end

addhook("minute","tf2.craft.minute")
function tf2.craft.minute()
local pl=game("sv_maxplayers")
	if (tf2.craft.enabled) then
		for lawlz=1,pl do
			local x=math.random(1,2)
			local y=math.random(1,10)
			if (player(lawlz,"exists")) then
				if (x==2) then
					equip(lawlz,1,"equip")
				end
				if (y==5) then
					if (ischristmas) then
						local crate=math.random(1,4)
					else
						local crate=math.random(1,3)
					end
					if (crate==1) then
						equip(lawlz,47,"equip")
					end
					if (crate==2) then
						equip(lawlz,46,"equip")
					end
					if (crate==3) then
						equip(lawlz,54,"equip")
					end
					if (crate==4) then
						equip(lawlz,55,"equip")
					end
				end
				tf2.craft.addcredits(lawlz,1)
			end
		end
	end
	for id=1,pl do
		if (player(id,"exists")) then
			player_save(id)
		end
	end
end

function plural(int,word)
	if (int==1) then
		return word
	else
		return word.."s"
	end
end

function craftmenu(id)
	if (ischristmas) then
		menu(id,"Craft@b,Fabricate Reclaimed Metal|3 Scrap Metal,Fabricate random weapon|1 Reclaimed Metal,Combine Reclaimed Metal|3 Reclaimed Metal,Fabricate class token|2 Reclaimed Metal,Fabricate headgear|1 Refined Metal,Fabricate class headgear|3 Refined Metal+Class Token,Fabricate event items|Christmas!")
	else
		menu(id,"Craft@b,Fabricate Reclaimed Metal|3 Scrap Metal,Fabricate random weapon|1 Reclaimed Metal,Combine Reclaimed Metal|3 Reclaimed Metal,Fabricate class token|2 Reclaimed Metal,Fabricate headgear|1 Refined Metal,Fabricate class headgear|3 Refined Metal+Class Token")
	end
end

function storemenu(id)
	if (ischristmas) then
		menu(id,"Store@b,You have "..tf2.craft.credits[id].." Game Credits,,Weapons,Miscellaneous,Event Items")
	else
		menu(id,"Store@b,You have "..tf2.craft.credits[id].." Game Credits,,Weapons,Miscellaneous")
	end
end

function trademenu(id)
	menu(id,"Trading,Trade,Give Game Credits")
end

function trade(id,source,item,count)
	if (tf2.craft.weaponstack[source][item]~=nil and tf2.craft.weaponstack[source][item]>=count) then
		if (item~=53 and item~=1 and item~=2 and item~=100 and item~=113) then
			tf2.craft.weaponstack[source][item]=tf2.craft.weaponstack[source][item]-count
			tf2.craft.weaponstack[id][item]=tf2.craft.weaponstack[id][item]+count
			msg2(source,"You have given "..count.." "..plural(count,crafts[item].name).." to "..player(id,"name"))
			msg2(id,"You have received "..count.." "..plural(count,crafts[item].name).." from "..player(source,"name"))
		end
	end
	if (item==53 and item~=1 and item~=2 and item~=100 and item~=113) then
		if (tf2.craft.credits[source]>=count) then
			tf2.craft.credits[source]=tf2.craft.credits[source]-count
			tf2.craft.credits[id]=tf2.craft.credits[id]+count
			msg2(source,"You have given "..count.." "..plural(count,"Game Credit").." to "..player(id,"name"))
			msg2(id,"You have received "..count.." "..plural(count,"Game Credit").." from "..player(source,"name"))
		end
	elseif (item~=53 and item==1 and item~=2 and item~=100 and item~=113) then
		if (tf2.craft.scrapnumber[source]>=count) then
			tf2.craft.scrapnumber[source]=tf2.craft.scrapnumber[source]-count
			tf2.craft.scrapnumber[id]=tf2.craft.scrapnumber[id]+count
			msg2(source,"You have given "..count.." Scrap Metal to "..player(id,"name"))
			msg2(id,"You have received "..count.." Scrap Metal from "..player(source,"name"))
		end
	elseif (item~=53 and item~=1 and item==2 and item~=100 and item~=113) then
		if (tf2.craft.reclaimednumber[source]>=count) then
			tf2.craft.reclaimednumber[source]=tf2.craft.reclaimednumber[source]-count
			tf2.craft.reclaimednumber[id]=tf2.craft.reclaimednumber[id]+count
			msg2(source,"You have given "..count.." Reclaimed Metal to "..player(id,"name"))
			msg2(id,"You have received "..count.." Reclaimed Metal from "..player(source,"name"))
		end
	elseif (item~=53 and item~=1 and item~=2 and item==100 and item~=113) then
		if (tf2.craft.refinednumber[source]>=count) then
			tf2.craft.refinednumber[source]=tf2.craft.refinednumber[source]-count
			tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]+count
			msg2(source,"You have given "..count.." Refined Metal to "..player(id,"name"))
			msg2(id,"You have received "..count.." Refined Metal from "..player(source,"name"))
		end
	elseif (item~=53 and item~=1 and item~=2 and item~=100 and item==113) then
		if (tf2.craft.christmasnumber[source]>=count) then
			tf2.craft.christmasnumber[source]=tf2.craft.christmasnumber[source]-count
			tf2.craft.christmasnumber[id]=tf2.craft.christmasnumber[id]+count
			msg2(source,"You have given "..count.." Enchanted Metal to "..player(id,"name"))
			msg2(id,"You have received "..count.." Enchanted Metal from "..player(source,"name"))
		end
	end
end

function realprice(price,sale)
	if (sale>0) then
		return price-((price/100)*sale)
	else
		return price
	end
end

function shopitem(item)
	if (tf2.craft.price[item].salepercent>0) then
		--return (math.ceil(realprice(tf2.craft.price[item].price,tf2.craft.price[item].salepercent))-0.01).." ("..tf2.craft.price[item].salepercent.."% SALE!)"
		return realprice(tf2.craft.price[item].price,tf2.craft.price[item].salepercent).." ("..tf2.craft.price[item].salepercent.."% SALE!)"
	else
		return tf2.craft.price[item].price
	end
end

function storesels(id,sel)
	if (sel=="hats") then
		menu(id,"Hats Store@b,Milkman|"..shopitem(51)..",Familiar Fez|"..shopitem(52))
	end
	if (sel=="weps") then
		menu(id,"Weapons Store@b,The Afterburner|"..shopitem(20)..",Cloak and Dagger|"..shopitem(14))
	end
	if (sel=="misc") then
		menu(id,"Miscellaneous Store@b,Supply Crate Series #1|"..shopitem(46)..",Supply Key|"..shopitem(48)..",Scrap Metal|"..shopitem(1)..",Reclaimed Metal|"..shopitem(2)..",Refined Metal|"..shopitem(30))
	end
	if (sel=="event") then
		menu(id,"Event Items Store@b,Santa's Hat (NEW!)|"..shopitem(40)..",Rudolph's Magic Antlers (NEW!)|"..shopitem(45)..",Gift Launcher (NEW!)|"..shopitem(41)..",Santa Caller (NEW!)|"..shopitem(42)..",Christmas Spirit (NEW!)|"..shopitem(44)..",Christmas Festive Crate|"..shopitem(47)..",Christmas Key|"..shopitem(49)..",Santa's Enchanted Metal|"..shopitem(43))
	end
end

function storebuy(id,item,price)
	if (tf2.craft.credits[id]>=price) then
		tf2.craft.credits[id]=tf2.craft.credits[id]-price
		tf2.craft.additem(id,item)
		msg(player(id,"name").." has bought: "..crafts[item].name)
	end
end

tf2.craft.tradestate=initArray2(32,0)
tf2.craft.tradingto=initArray2(32,0)
tf2.craft.tradingwhat=initArray2(32,0)
tf2.craft.tradinghowmuch=initArray2(32,0)
tf2.craft.inboundrequest=initArray2(32,false)
tf2.craft.requestfrom=initArray2(32,0)

addhook("menu","tf2.craft.storentrade")
function tf2.craft.storentrade(id,menu,sel)
	if (menu=="Trading") then
		if (sel==1) then
			msg2(id,"Write the ID of the player you wish to trade with.")
			tf2.craft.tradestate[id]=1
		end
	end
	if (menu=="Trade Request") then
		if (sel==1) then
			trade(id,tf2.craft.requestfrom[id],tf2.craft.tradingwhat[tf2.craft.requestfrom[id]],tf2.craft.tradinghowmuch[tf2.craft.requestfrom[id]])
			msg2(tf2.craft.requestfrom[id],"Your trading request has been accepted!")
		end
		if (sel==2) then
			msg2(tf2.craft.requestfrom[id],"Your trading request has been denied.")
		end
	end
	if (menu=="Store") then
		if (sel==2) then
			storesels(id,"hats")
		end
		if (sel==3) then
			storesels(id,"weps")
		end
		if (sel==4) then
			storesels(id,"misc")
		end
		if (sel==5) then
			storesels(id,"event")
		end
	end
	if (menu=="Hats Store") then
		if (sel==1) then
			storebuy(id,51,realprice(tf2.craft.price[51].price,tf2.craft.price[51].salepercent))
		end
		if (sel==2) then
			storebuy(id,52,realprice(tf2.craft.price[52].price,tf2.craft.price[52].salepercent))
		end
	end
	if (menu=="Weapons Store") then
		if (sel==1) then
			storebuy(id,20,realprice(tf2.craft.price[20].price,tf2.craft.price[20].salepercent))
		end
		if (sel==2) then
			storebuy(id,14,realprice(tf2.craft.price[14].price,tf2.craft.price[14].salepercent))
		end
	end
	if (menu=="Miscellaneous Store") then
		if (sel==1) then
			storebuy(id,46,realprice(tf2.craft.price[46].price,tf2.craft.price[46].salepercent))
		end
		if (sel==2) then
			storebuy(id,48,realprice(tf2.craft.price[48].price,tf2.craft.price[48].salepercent))
		end
		if (sel==3) then
			storebuy(id,1,realprice(tf2.craft.price[1].price,tf2.craft.price[1].salepercent))
		end
		if (sel==4) then
			storebuy(id,2,realprice(tf2.craft.price[2].price,tf2.craft.price[2].salepercent))
		end
		if (sel==5) then
			storebuy(id,30,realprice(tf2.craft.price[30].price,tf2.craft.price[30].salepercent))
		end
	end
	if (menu=="Event Items Store") then
		if (sel==1) then
			storebuy(id,40,realprice(tf2.craft.price[40].price,tf2.craft.price[40].salepercent))
		end
		if (sel==2) then
			storebuy(id,45,realprice(tf2.craft.price[45].price,tf2.craft.price[45].salepercent))
		end
		if (sel==3) then
			storebuy(id,41,realprice(tf2.craft.price[41].price,tf2.craft.price[41].salepercent))
		end
		if (sel==4) then
			storebuy(id,42,realprice(tf2.craft.price[42].price,tf2.craft.price[42].salepercent))
		end
		if (sel==5) then
			storebuy(id,44,realprice(tf2.craft.price[44].price,tf2.craft.price[44].salepercent))
		end
		if (sel==6) then
			storebuy(id,47,realprice(tf2.craft.price[47].price,tf2.craft.price[47].salepercent))
		end
		if (sel==7) then
			storebuy(id,49,realprice(tf2.craft.price[49].price,tf2.craft.price[49].salepercent))
		end
		if (sel==8) then
			storebuy(id,43,realprice(tf2.craft.price[43].price,tf2.craft.price[43].salepercent))
		end
	end
end

addhook("say","tf2.craft.trading")
function tf2.craft.trading(id,t)
	local tid=tonumber(t)
	if (t:sub(1,9)=="!finditem") then
		iname=t:sub(11)
		msg2(id,"You tried to find item "..iname)
		for items=1,52 do
			if (iname==crafts[items].name) then
				msg2(id,iname.." has the ID "..items)
			end
		end
	end
	if (tf2.craft.tradestate[id]>=1 and tf2.craft.tradestate[id]<=4) then
		if (tf2.craft.tradestate[id]==1) then
			if (tid~=nil and tid>=1 and tid<=32 and player(tid,"bot")==false) then
				tf2.craft.tradingto[id]=tid
				msg2(id,"Write the name of the item you will be trading.")
				tf2.craft.tradestate[id]=2
				--timer(100,"parse","lua tf2.craft.tradestate["..id.."]=2")
			else
				msg2(id,t.." isn't a valid ID!")
				tf2.craft.tradestate[id]=0
			end
			return 1
		end
		if (tf2.craft.tradestate[id]==2) then
			for items=1,52 do
				if (t==crafts[items].name) then
					if (crafts[items].name~=nil) then
						tf2.craft.tradingwhat[id]=items
						msg2(id,"Write the amount of the items you will be trading.")
					tf2.craft.tradestate[id]=3
					end
				end
			end
			return 1
		end
		if (tf2.craft.tradestate[id]==3) then
			if (tid~=nil and tid>=1 and tid<=8) then
				tf2.craft.tradinghowmuch[id]=tid
				if (tf2.craft.weaponstack[id][tf2.craft.tradingwhat[id]]~=nil) then
					msg2(id,"Awaiting for receiver's confirmation...")
					tf2.craft.tradestate[id]=4
					tf2.craft.tradestate[tf2.craft.tradingto[id]]=4
					tf2.craft.inboundrequest[tf2.craft.tradingto[id]]=true
					tf2.craft.requestfrom[tf2.craft.tradingto[id]]=id
					msg2(tf2.craft.tradingto[id],player(tf2.craft.requestfrom[id],"name").." wants to trade "..tf2.craft.tradinghowmuch[id].." "..plural(tf2.craft.tradinghowmuch[id],crafts[tf2.craft.tradingwhat[id]].name).." with you!")
					msg2(tf2.craft.tradingto[id],"Press 1 to accept the request or press 2 (or ESC) to deny it.")
					menu(tf2.craft.tradingto[id],"Trade Request@i,Accept,Deny")
				else
					msg2(id,"You don't have enough items!")
					tf2.craft.tradestate[id]=0
				end
			else
				msg2(id,"You can't trade "..t.." items!")
				tf2.craft.tradestate[id]=0
			end
			return 1
		end
	end
end

function backpack(id,slot)
	if (slot==1) then
		if (tf2.classes.primaryunlock[id][tf2.classes.class[id]]==0) then
			if (tf2.classes.class[id]==1) then
				return "Scattergun - Level 1 Scattergun"
			end
			if (tf2.classes.class[id]==2) then
				return "Rocket Launcher - Level 1 Rocket Launcher"
			end
			if (tf2.classes.class[id]==3) then
				return "Flamethrower - Level 1 Flamethrower"
			end
			if (tf2.classes.class[id]==4) then
				return "Grenade Launcher - Level 1 Grenade Launcher"
			end
			if (tf2.classes.class[id]==5) then
				return "Minigun - Level 1 Minigun"
			end
			if (tf2.classes.class[id]==6) then
				return "Shotgun - Level 1 Shotgun"
			end
			if (tf2.classes.class[id]==7) then
				return "Syringe Gun - Level 1 Syringe Gun"
			end
			if (tf2.classes.class[id]==8) then
				return "Sniper Rifle - Level 1 Sniper Rifle"
			end
			if (tf2.classes.class[id]==9) then
				return "Revolver - Level 1 Revolver"
			end
		else
			return (crafts[tf2.classes.primaryunlock[id][tf2.classes.class[id]]].name.." - "..crafts[tf2.classes.primaryunlock[id][tf2.classes.class[id]]].desc)
		end
	elseif (slot==2) then
		if (tf2.classes.secondaryunlock[id][tf2.classes.class[id]]==0) then
			if (tf2.classes.class[id]==1) then
				return "Pistol - Level 1 Pistol"
			end
			if (tf2.classes.class[id]==2) then
				return "Shotgun - Level 1 Shotgun"
			end
			if (tf2.classes.class[id]==3) then
				return "Shotgun - Level 1 Shotgun"
			end
			if (tf2.classes.class[id]==4) then
				return "Stickybomb launcher - Level 1 Stickybomb Launcher"
			end
			if (tf2.classes.class[id]==5) then
				return "Shotgun - Level 1 Shotgun"
			end
			if (tf2.classes.class[id]==6) then
				return "Pistol - Level 1 Pistol"
			end
			if (tf2.classes.class[id]==7) then
				return "Medigun - Level 1 Medigun"
			end
			if (tf2.classes.class[id]==8) then
				return "SMG - Level 1 SMG"
			end
			if (tf2.classes.class[id]==9) then
				return "Electro sapper"
			end
		else
			return (crafts[tf2.classes.secondaryunlock[id][tf2.classes.class[id]]].name.." - "..crafts[tf2.classes.secondaryunlock[id][tf2.classes.class[id]]].desc)
		end
	elseif (slot==3) then
		if (tf2.classes.meleeunlock[id][tf2.classes.class[id]]==0) then
			if (tf2.classes.class[id]==1) then
				return "Bat - Level 1 Bat"
			end
			if (tf2.classes.class[id]==2) then
				return "Shovel - Level 1 Shovel"
			end
			if (tf2.classes.class[id]==3) then
				return "Fireaxe - Level 1 Fireaxe"
			end
			if (tf2.classes.class[id]==4) then
				return "Bottle - Level 1 Bottle"
			end
			if (tf2.classes.class[id]==5) then
				return "Fists - Level 1 Fists"
			end
			if (tf2.classes.class[id]==6) then
				return "Wrench - Level 1 Wrench"
			end
			if (tf2.classes.class[id]==7) then
				return "Bonesaw - Level 1 Bonesaw"
			end
			if (tf2.classes.class[id]==8) then
				return "Kukri - Level 1 Kukri"
			end
			if (tf2.classes.class[id]==9) then
				return "Knife - Level 1 Knife"
			end
		else
			return (crafts[tf2.classes.meleeunlock[id][tf2.classes.class[id]]].name.." - "..crafts[tf2.classes.meleeunlock[id][tf2.classes.class[id]]].desc)
		end
	elseif (slot==4) then
		if (tf2.classes.pdaunlock[id][tf2.classes.class[id]]==0) then
			if (tf2.classes.class[id]>=1 and tf2.classes.class[id]<=8) then
				return "None"
			else
				return "Invis watch - Level 1 Invis watch"
			end
		else
			return (crafts[tf2.classes.pdaunlock[id][tf2.classes.class[id]]].name.." - "..crafts[tf2.classes.pdaunlock[id][tf2.classes.class[id]]].desc)
		end
	elseif (slot==5) then
		if (tf2.classes.hatunlock[id][tf2.classes.class[id]]==0) then
			return "None"
		else
			return (crafts[tf2.classes.hatunlock[id][tf2.classes.class[id]]].name)
		end
	end
end

function upgradesmenu(id)
	menu(id,"Backpack@b,Primary Weapon|"..backpack(id,1)..",Secondary Weapon|"..backpack(id,2)..",Melee Weapon|"..backpack(id,3)..",PDA|"..backpack(id,4)..",Head|"..backpack(id,5)..",You have "..tf2.craft.scrapnumber[id].." Scrap Metal,You have "..tf2.craft.reclaimednumber[id].." Reclaimed Metal,You have "..tf2.craft.refinednumber[id].." Refined Metal,Crates|Uncrate some")
end

function weaponstack(id,weapon)
	if (tf2.craft.weaponstack[id][weapon]~=nil and tf2.craft.weaponstack[id][weapon]>=1) then
		return crafts[weapon].name.."|"..crafts[weapon].func
	else
		return ""
	end
end

function weaponchoice(id,slot)
	if (slot==1) then
		if (tf2.classes.class[id]==1) then
			menu(id,"Switch Primary Weapon@b,Default Weapon,"..weaponstack(id,3))
			tf2.craft.selectstack[id]=3
		elseif (tf2.classes.class[id]==2) then
			menu(id,"Switch Primary Weapon@b,Default Weapon,"..weaponstack(id,4))
			tf2.craft.selectstack[id]=4
		elseif (tf2.classes.class[id]==3) then
			menu(id,"Switch Primary Weapon@b,Default Weapon,"..weaponstack(id,5)..","..weaponstack(id,20))
			tf2.craft.selectstack[id]=5
			tf2.craft.selectstack2[id]=20
		elseif (tf2.classes.class[id]==4 or tf2.classes.class[id]==6) then
			menu(id,"Switch Primary Weapon@b,Default Weapon")
		elseif (tf2.classes.class[id]==5) then
			menu(id,"Switch Primary Weapon@b,Default Weapon,"..weaponstack(id,12))
			tf2.craft.selectstack[id]=12
		elseif (tf2.classes.class[id]==7) then
			menu(id,"Switch Primary Weapon@b,Default Weapon,"..weaponstack(id,13)..","..weaponstack(id,19))
			tf2.craft.selectstack[id]=13
			tf2.craft.selectstack2[id]=19
		elseif (tf2.classes.class[id]==8) then
			menu(id,"Switch Primary Weapon@b,Default Weapon,"..weaponstack(id,10))
			tf2.craft.selectstack[id]=10
		elseif (tf2.classes.class[id]==9) then
			menu(id,"Switch Primary Weapon@b,Default Weapon")
		end
	end
	if (slot==2) then
		if (tf2.classes.class[id]==1) then
			menu(id,"Switch Secondary Weapon@b,Default Weapon,"..weaponstack(id,17))
			tf2.craft.selectstack[id]=17
		elseif (tf2.classes.class[id]>=2 and tf2.classes.class[id]<=3 or tf2.classes.class[id]==6 or tf2.classes.class[id]==7 or tf2.classes.class[id]==9) then
			menu(id,"Switch Secondary Weapon@b,Default Weapon")
		elseif (tf2.classes.class[id]==4) then
			menu(id,"Switch Secondary Weapon@b,Default Weapon,"..weaponstack(id,6)..","..weaponstack(id,58))
			tf2.craft.selectstack[id]=6
			tf2.craft.selectstack2[id]=58
		elseif (tf2.classes.class[id]==5) then
			menu(id,"Switch Secondary Weapon@b,Default Weapon,"..weaponstack(id,7)..","..weaponstack(id,16))
			tf2.craft.selectstack[id]=7
			tf2.craft.selectstack2[id]=16
		elseif (tf2.classes.class[id]==8) then
			menu(id,"Switch Secondary Weapon@b,Default Weapon,"..weaponstack(id,15))
			tf2.craft.selectstack[id]=15
		end
	end
	if (slot==3) then
		if (tf2.classes.class[id]>=1 and tf2.classes.class[id]<=5 or tf2.classes.class[id]>=8 and tf2.classes.class[id]<=9) then
			menu(id,"Switch Melee Weapon@b,Default Weapon")
		elseif (tf2.classes.class[id]==6) then
			menu(id,"Switch Melee Weapon@b,Default Weapon,"..weaponstack(id,8)..","..weaponstack(id,18))
			tf2.craft.selectstack[id]=8
			tf2.craft.selectstack2[id]=18
		elseif (tf2.classes.class[id]==7) then
			menu(id,"Switch Melee Weapon@b,Default Weapon,"..weaponstack(id,9))
			tf2.craft.selectstack[id]=9
		end
	end
	if (slot==4) then
		if (tf2.classes.class[id]==9) then
			menu(id,"Switch PDA@b,Default Weapon,"..weaponstack(id,11)..","..weaponstack(id,14))
			tf2.craft.selectstack[id]=11
			tf2.craft.selectstack2[id]=14
		end
	end
	if (slot==5) then
		if (tf2.classes.class[id]==1) then
			menu(id,"Switch Hat@b,None,"..weaponstack(id,31)..","..weaponstack(id,51))
			tf2.craft.selectstack[id]=31
			tf2.craft.selectstack2[id]=53
		elseif (tf2.classes.class[id]==2) then
			menu(id,"Switch Hat@b,None,"..weaponstack(id,32)..","..weaponstack(id,61))
			tf2.craft.selectstack[id]=32
			tf2.craft.selectstack2[id]=61
		elseif (tf2.classes.class[id]==3) then
			menu(id,"Switch Hat@b,None,"..weaponstack(id,33))
			tf2.craft.selectstack[id]=33
		elseif (tf2.classes.class[id]==4) then
			menu(id,"Switch Hat@b,None,"..weaponstack(id,34))
			tf2.craft.selectstack[id]=34
		elseif (tf2.classes.class[id]==5) then
			menu(id,"Switch Hat@b,None,"..weaponstack(id,35)..","..weaponstack(id,50)..","..weaponstack(id,60)..","..weaponstack(id,62))
			tf2.craft.selectstack[id]=35
			tf2.craft.selectstack2[id]=50
			tf2.craft.selectstack3[id]=60
			tf2.craft.selectstack4[id]=62
		elseif (tf2.classes.class[id]==6) then
			menu(id,"Switch Hat@b,None,"..weaponstack(id,36))
			tf2.craft.selectstack[id]=36
		elseif (tf2.classes.class[id]==7) then
			menu(id,"Switch Hat@b,None,"..weaponstack(id,37))
			tf2.craft.selectstack[id]=37
		elseif (tf2.classes.class[id]==8) then
			menu(id,"Switch Hat@b,None,"..weaponstack(id,38))
			tf2.craft.selectstack[id]=38
		elseif (tf2.classes.class[id]==9) then
			menu(id,"Switch Hat@b,None,"..weaponstack(id,39)..","..weaponstack(id,52))
			tf2.craft.selectstack[id]=39
			tf2.craft.selectstack2[id]=52
		end
	end
end

function eventchoice(id,slot)
	if (slot==1) then
		if (tf2.classes.class[id]==2) then
			menu(id,"Switch Primary Event Weapon@b,None,"..weaponstack(id,41))
			tf2.craft.selectstack[id]=41
		end
	end
	if (slot==4) then
		if (tf2.classes.class[id]==7) then
			menu(id,"Switch Event PDA@b,None,"..weaponstack(id,42))
			tf2.craft.selectstack[id]=42
		end
		if (tf2.classes.class[id]==5) then
			menu(id,"Switch Event PDA@b,None,"..weaponstack(id,44))
			tf2.craft.selectstack[id]=44
		end
	end
	if (slot==5) then
		menu(id,"Switch Event Hat@b,None,"..weaponstack(id,40)..","..weaponstack(id,45))
		tf2.craft.selectstack[id]=40
		tf2.craft.selectstack2[id]=45
	end
end

function whattoken(id)
	menu(id,"Select Class Token,Scout,Soldier,Pyro,Demoman,Heavy,Engineer,Medic,Sniper,Spy")
end


function eventmenu(id)
	menu(id,"Event Items Menu,Equip Event Item,Craft Event Resource,Craft Event Weapon,Craft Event Hat,You have "..tf2.craft.christmasnumber[id].." Enchanted Metal")
end

function eventitems(id)
	menu(id,"Equip Event Item@b,Primary|"..backpack(id,1)..",Secondary|"..backpack(id,2)..",Melee|"..backpack(id,3)..",PDA|"..backpack(id,4)..",Hat|"..backpack(id,5))
end

function craftreschristmas(id)
	menu(id,"Craft Event Resource@b,Fabricate Santa's Enchanted Metal|2 Refined Metal")
end

function craftwepchristmas(id)
	menu(id,"Craft Event Weapon@b,Fabricate Gift Launcher|Soldier Token+1 Enchanted Metal,Fabricate Santa Caller|Medic Token+1 Enchanted Metal,Fabricate \"Christmas Spirit\"|Heavy Token+1 Enchanted Metal")
end

function crafthatchristmas(id)
	menu(id,"Craft Event Hat@b,Craft Santa's Hat|2 Enchanted Metal,Craft Rudolph's Magic Antlers|2 Enchanted Metal")
end

addhook("menu","craftables")
function craftables(id,menu,sel)
	if (menu=="Craft") then
		if (sel==1) then
			if (tf2.craft.scrapnumber[id]>=3) then
				tf2.craft.scrapnumber[id]=tf2.craft.scrapnumber[id]-3
				craft(id,2,1,1,1)
			end
		end
		if (sel==2) then
			if (tf2.craft.reclaimednumber[id]>=1) then
				local item=math.random(3,17)
				tf2.craft.reclaimednumber[id]=tf2.craft.reclaimednumber[id]-1
				craft(id,item,2)
			end
		end
		if (sel==3) then
			if (tf2.craft.reclaimednumber[id]>=3) then
				tf2.craft.reclaimednumber[id]=tf2.craft.reclaimednumber[id]-3
				craft(id,30,2,2,2)
			end
		end
		if (sel==4) then
			if (tf2.craft.reclaimednumber[id]>=2) then
				local token=math.random(21,29)
				tf2.craft.reclaimednumber[id]=tf2.craft.reclaimednumber[id]-2
				craft(id,token,2,2)
			end
		end
		if (sel==5) then
			if (tf2.craft.refinednumber[id]>=3) then
				local hat=math.random(31,39)
				tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]-3
				craft(id,hat,30,30,30)
			end
		end
		if (sel==6) then
			if (tf2.craft.refinednumber[id]>=3) then
				whattoken(id)
			end
		end
		if (sel==7) then
			eventmenu(id)
		end
	end
	if (menu=="Select Class Token") then
		if (sel==1) then
			if (tf2.craft.token[id][1]>=1) then
				local whathat=math.random(1,2)
				tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]-3
				tf2.craft.token[id][1]=tf2.craft.token[id][1]-1
				print(whathat)
				craft(id,31,30,30,30,21)
			end
		end
		if (sel==2) then
			if (tf2.craft.token[id][2]>=1) then
				tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]-3
				tf2.craft.token[id][2]=tf2.craft.token[id][2]-1
				craft(id,32,30,30,30,22)
			end
		end
		if (sel==3) then
			if (tf2.craft.token[id][3]>=1) then
				tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]-3
				tf2.craft.token[id][3]=tf2.craft.token[id][3]-1
				craft(id,33,30,30,30,23)
			end
		end
		if (sel==4) then
			if (tf2.craft.token[id][4]>=1) then
				tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]-3
				tf2.craft.token[id][4]=tf2.craft.token[id][4]-1
				craft(id,34,30,30,30,24)
			end
		end
		if (sel==5) then
			if (tf2.craft.token[id][5]>=1) then
				local whathat=math.random(1,2)
				tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]-3
				tf2.craft.token[id][5]=tf2.craft.token[id][5]-1
				if (whathat==1) then
					craft(id,35,30,30,30,25)
				else
					craft(id,50,30,30,30,25)
				end
			end
		end
		if (sel==6) then
			if (tf2.craft.token[id][6]>=1) then
				tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]-3
				tf2.craft.token[id][6]=tf2.craft.token[id][6]-1
				craft(id,36,30,30,30,26)
			end
		end
		if (sel==7) then
			if (tf2.craft.token[id][7]>=1) then
				tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]-3
				tf2.craft.token[id][7]=tf2.craft.token[id][7]-1
				craft(id,37,30,30,30,27)
			end
		end
		if (sel==8) then
			if (tf2.craft.token[id][8]>=1) then
				tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]-3
				tf2.craft.token[id][8]=tf2.craft.token[id][8]-1
				craft(id,38,30,30,30,28)
			end
		end
		if (sel==9) then
			if (tf2.craft.token[id][9]>=1) then
				tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]-3
				tf2.craft.token[id][9]=tf2.craft.token[id][9]-1
				craft(id,39,30,30,30,29)
			end
		end
	end
	if (menu=="Event Items Menu") then
		if (sel==1) then
			eventitems(id)
		end
		if (sel==2) then
			craftreschristmas(id)
		end
		if (sel==3) then
			craftwepchristmas(id)
		end
		if (sel==4) then
			crafthatchristmas(id)
		end
	end
	if (menu=="Equip Event Item") then
		if (sel==1) then
			eventchoice(id,1)
		end
		if (sel==4) then
			eventchoice(id,4)
		end
		if (sel==5) then
			eventchoice(id,5)
		end
	end
	if (menu=="Craft Event Resource") then
		if (sel==1) then
			if (tf2.craft.refinednumber[id]>=2) then
				tf2.craft.refinednumber[id]=tf2.craft.refinednumber[id]-2
				craft(id,43,30,30)
				eventmenu(id)
			end
		end
	end
	if (menu=="Craft Event Weapon") then
		if (sel==1) then
			if (tf2.craft.token[id][2]>=1 and tf2.craft.christmasnumber[id]>=1) then
				tf2.craft.christmasnumber[id]=tf2.craft.christmasnumber[id]-1
				tf2.craft.token[id][2]=tf2.craft.token[id][2]-1
				craft(id,41,22,43)
				eventmenu(id)
			end
		end
		if (sel==2) then
			if (tf2.craft.token[id][7]>=1 and tf2.craft.christmasnumber[id]>=1) then
				tf2.craft.christmasnumber[id]=tf2.craft.christmasnumber[id]-1
				tf2.craft.token[id][7]=tf2.craft.token[id][7]-1
				craft(id,42,27,43)
				eventmenu(id)
			end
		end
		if (sel==3) then
			if (tf2.craft.token[id][5]>=1 and tf2.craft.christmasnumber[id]>=1) then
				tf2.craft.christmasnumber[id]=tf2.craft.christmasnumber[id]-1
				tf2.craft.token[id][5]=tf2.craft.token[id][5]-1
				craft(id,44,25,43)
				eventmenu(id)
			end
		end
	end
	if (menu=="Craft Event Hat") then
		if (sel==1) then
			if (tf2.craft.christmasnumber[id]>=2) then
				tf2.craft.christmasnumber[id]=tf2.craft.christmasnumber[id]-2
				craft(id,40,43,43)
				eventmenu(id)
			end
		end
		if (sel==2) then
			if (tf2.craft.christmasnumber[id]>=2) then
				tf2.craft.christmasnumber[id]=tf2.craft.christmasnumber[id]-2
				craft(id,45,43,43)
				eventmenu(id)
			end
		end
	end
end

function rand(x,y)
	out=math.random(x,y)
	return out
end

addhook("menu","tf2.craft.equipping")
function tf2.craft.equipping(id,menu,sel)
	if (menu=="Switch Primary Weapon") then
		if (sel==1) then
			tf2.classes.primaryunlock[id][tf2.classes.class[id]]=0
		elseif (sel==2) then
			tf2.classes.primaryunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack[id]
		elseif (sel==3) then
			tf2.classes.primaryunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack2[id]
		elseif (sel==0) then
			tf2.craft.selectstack[id]=0
		end
	end
	if (menu=="Switch Secondary Weapon") then
		if (sel==1) then
			tf2.classes.secondaryunlock[id][tf2.classes.class[id]]=0
		elseif (sel==2) then
			tf2.classes.secondaryunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack[id]
		elseif (sel>=3 and sel<=9) then
			tf2.classes.secondaryunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack2[id]
		elseif (sel==0) then
			tf2.craft.selectstack[id]=0
		end
	end
	if (menu=="Switch Melee Weapon") then
		if (sel==1) then
			tf2.classes.meleeunlock[id][tf2.classes.class[id]]=0
		elseif (sel==2) then
			tf2.classes.meleeunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack[id]
		elseif (sel>=3 and sel<=9) then
			tf2.classes.meleeunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack2[id]
		elseif (sel==0) then
			tf2.craft.selectstack[id]=0
		end
	end
	if (menu=="Switch PDA") then
		if (sel==1) then
			tf2.classes.pdaunlock[id][tf2.classes.class[id]]=0
		elseif (sel==2) then
			tf2.classes.pdaunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack[id]
		elseif (sel>=3 and sel<=9) then
			tf2.classes.pdaunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack2[id]
		elseif (sel==0) then
			tf2.craft.selectstack[id]=0
		end
	end 
	if (menu=="Switch Hat") then
		if (sel==1) then
			freeimage(hat[id])
			tf2.classes.hatunlock[id][tf2.classes.class[id]]=0
			hat[id]=0
		elseif (sel==2 and tf2.classes.hatunlock[id][tf2.classes.class[id]]~=tf2.craft.selectstack[id]) then
			if (tf2.classes.hatunlock[id][tf2.classes.class[id]]~=0) then
				freeimage(hat[id])
			end
			hat[id]=image(crafts[tf2.craft.selectstack[id]].image,1,0,200+id)
			tf2.classes.hatunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack[id]
		elseif (sel==3 and tf2.classes.hatunlock[id][tf2.classes.class[id]]~=tf2.craft.selectstack2[id]) then
			if (tf2.classes.hatunlock[id][tf2.classes.class[id]]~=0) then
				freeimage(hat[id])
			end
			hat[id]=image(crafts[tf2.craft.selectstack2[id]].image,1,0,200+id)
			tf2.classes.hatunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack2[id]
		elseif (sel==4 and tf2.classes.hatunlock[id][tf2.classes.class[id]]~=tf2.craft.selectstack3[id]) then
			if (tf2.classes.hatunlock[id][tf2.classes.class[id]]~=0) then
				freeimage(hat[id])
			end
			hat[id]=image(crafts[tf2.craft.selectstack3[id]].image,1,0,200+id)
			tf2.classes.hatunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack3[id]
		elseif (sel>=5 and sel<=9 and tf2.classes.hatunlock[id][tf2.classes.class[id]]~=tf2.craft.selectstack4[id]) then
			if (tf2.classes.hatunlock[id][tf2.classes.class[id]]~=0) then
				freeimage(hat[id])
			end
			hat[id]=image(crafts[tf2.craft.selectstack4[id]].image,1,0,200+id)
			tf2.classes.hatunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack4[id]
		elseif (sel==0) then
			tf2.craft.selectstack[id]=0
		end
	end
	if (menu=="Switch Primary Event Weapon") then
		if (sel==1) then
			tf2.classes.primaryunlock[id][tf2.classes.class[id]]=0
		elseif (sel==2) then
			tf2.classes.primaryunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack[id]
		end
	end
	if (menu=="Switch Event PDA") then
		if (sel==1) then
			tf2.classes.pdaunlock[id][tf2.classes.class[id]]=0
		elseif (sel==2) then
			tf2.classes.pdaunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack[id]
		end
	end
	if (menu=="Switch Event Hat") then
		if (sel==1) then
			freeimage(hat[id])
			tf2.classes.hatunlock[id][tf2.classes.class[id]]=0
		elseif (sel==2 and tf2.classes.hatunlock[id][tf2.classes.class[id]]~=tf2.craft.selectstack[id]) then
			if (tf2.classes.hatunlock[id][tf2.classes.class[id]]~=0) then
				freeimage(hat[id])
		end
			hat[id]=image(crafts[tf2.craft.selectstack[id]].image,1,0,200+id)
			tf2.classes.hatunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack[id]
		elseif (sel>=3 and sel<=9 and tf2.classes.hatunlock[id][tf2.classes.class[id]]~=tf2.craft.selectstack2[id]) then
			if (tf2.classes.hatunlock[id][tf2.classes.class[id]]~=0) then
				freeimage(hat[id])
			end
			hat[id]=image(crafts[tf2.craft.selectstack2[id]].image,1,0,200+id)
			tf2.classes.hatunlock[id][tf2.classes.class[id]]=tf2.craft.selectstack2[id]
		elseif (sel==0) then
			tf2.craft.selectstack[id]=0
		end
	end
end

function craft(id,result,input1,input2,input3,input4)
	if (input1==1 and input2==1 and input3==1 and result==2) then
		equip(id,2,"craft")
	end
	for res=3,17 do
		if (input1==2 and result==res) then
			equip(id,result,"craft")
		end
	end
	if (input1==2 and input2==2 and input3==2 and result==30) then
		equip(id,30,"craft")
	end
	if (input1==30 and input2==30 and input3==30 and result>=31 and result<=39) then
		equip(id,result,"craft")
	end
	if (input1==2 and input2==2 and result>=21 and result<=29) then
		equip(id,result,"craft")
	end
	if (input1==30 and input2==30 and result==43) then
		equip(id,result,"craft")
	end
	if (input1==22 and input2==43 and result==41) then
		equip(id,result,"craft")
	end
	if (input1==27 and input2==43 and result==42) then
		equip(id,result,"craft")
	end
	if (input1==43 and input2==43 and result==40) then
		equip(id,result,"craft")
	end
	if (input1==43 and input2==43 and result==45) then
		equip(id,result,"craft")
	end
	if (input1==25 and input2==43 and result==44) then
		equip(id,result,"craft")
	end
	if (input1==30 and input2==30 and input3==30 and result==50) then
		equip(id,result,"craft")
	end
end

function equip(id,item,mode)
	if (mode=="equip") then
		msg2(id,"You have found: "..crafts[item].name)
		msg(player(id,"name").." has found: "..crafts[item].name)
		tf2.craft.additem(id,item)
	elseif (mode=="craft") then
		if (item>=3 and item<=17) then
			menu(id,"Do you want to equip it?,Yes,No")
			tf2.craft.itemstack[id]=item
		end
		if (item>=21 and item<=29) then
			local class=item-20
			tf2.craft.token[id][class]=tf2.craft.token[id][class]+1
		end
		msg2(id,"You have crafted: "..crafts[item].name)
		msg(player(id,"name").." has crafted: "..crafts[item].name)
		tf2.craft.additem(id,item)
	elseif (mode=="uncrate") then
		msg2(id,"You have found "..crafts[item].name.." in your crate")
		msg(player(id,"name").." has found a "..crafts[item].name.." in a crate")
		tf2.craft.additem(id,item)
	end
end

addhook("menu","tf2.craft.equipmenu")
function tf2.craft.equipmenu(id,menu,sel)
	if (menu=="Do you want to equip it?") then
		if (sel==1) then
			if (crafts[tf2.craft.itemstack[id]].slot==1 and crafts[tf2.craft.itemstack[id]].class==tf2.classes.class[id]) then
				tf2.classes.primaryunlock[id][tf2.classes.class[id]]=tf2.craft.itemstack[id]
				tf2.craft.itemstack[id]=0
			elseif (crafts[tf2.craft.itemstack[id]].class~=tf2.classes.class[id]) then
				tf2.craft.itemstack[id]=0
			end
			if (crafts[tf2.craft.itemstack[id]].slot==2 and crafts[tf2.craft.itemstack[id]].class==tf2.classes.class[id]) then
				tf2.classes.secondaryunlock[id][tf2.classes.class[id]]=tf2.craft.itemstack[id]
				tf2.craft.itemstack[id]=0
			elseif (crafts[tf2.craft.itemstack[id]].class~=tf2.classes.class[id]) then
				tf2.craft.itemstack[id]=0
			end
			if (crafts[tf2.craft.itemstack[id]].slot==3 and crafts[tf2.craft.itemstack[id]].class==tf2.classes.class[id]) then
				tf2.classes.meleeunlock[id][tf2.classes.class[id]]=tf2.craft.itemstack[id]
				tf2.craft.itemstack[id]=0
			elseif (crafts[tf2.craft.itemstack[id]].class~=tf2.classes.class[id]) then
				tf2.craft.itemstack[id]=0
			end
			if (crafts[tf2.craft.itemstack[id]].slot==4 and crafts[tf2.craft.itemstack[id]].class==tf2.classes.class[id]) then
				tf2.classes.pdaunlock[id][tf2.classes.class[id]]=tf2.craft.itemstack[id]
				tf2.craft.itemstack[id]=0
			elseif (crafts[tf2.craft.itemstack[id]].class~=tf2.classes.class[id]) then
				tf2.craft.itemstack[id]=0
			end
			if (crafts[tf2.craft.itemstack[id]].slot==5 and crafts[tf2.craft.itemstack[id]].class==tf2.classes.class[id] or crafts[tf2.craft.itemstack[id]].class=="all") then
				tf2.classes.hat[id]=image(crafts[tf2.craft.itemstack[id]].image,1,0,200+id)
				tf2.craft.itemstack[id]=0
			end
		end
	end
end
